diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
index 8d5ac089f..0e49e289b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
@@ -5,6 +5,7 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
@@ -16,16 +17,17 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
-public class BlockLogicPistonBase extends BlockLogic
-{
+public class BlockLogicPistonBase extends BlockLogic {
     public static final int MASK_DIRECTION = 0b0000_0111;
     public static final int MASK_POWERED = 0b0000_1000;
 
@@ -79,111 +81,126 @@ public class BlockLogicPistonBase extends BlockLogic
 
     private final int maxPushedBlocks;
 
-    public BlockLogicPistonBase(@NotNull Block<?> block, int maxPushedBlocks)
-    {
-        super(block, Material.piston);
+    public BlockLogicPistonBase(@NotNull Block<?> block, int maxPushedBlocks) {
+        super(block, Materials.PISTON);
         this.maxPushedBlocks = maxPushedBlocks;
         block.withHardness(0.5F);
     }
 
     @Override
-	public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-    public void onPlacedByMob(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
+    public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
         Direction placementDirection = mob.getPlacementDirection(side).getOpposite();
         world.setBlockDataNotify(tilePos, placementDirection.getId());
-        if(!world.isClientSide) {
+        if (!world.isClientSide) {
             checkIfExtend(world, tilePos);
         }
     }
 
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         Direction placementDirection = side.getDirection();
         world.setBlockDataNotify(tilePos, placementDirection.getId());
-        if(!world.isClientSide) {
+        if (!world.isClientSide) {
             checkIfExtend(world, tilePos);
         }
     }
 
     @Override
-	public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id)
-    {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         checkIfExtend(world, tilePos);
     }
 
     @Override
-    public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos) {
-        if(!world.isClientSide && world.getTileEntity(tilePos) == null) {
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
+        if (!world.isClientSide && world.getTileEntity(tilePos) == null) {
             checkIfExtend(world, tilePos);
         }
     }
 
-    private void checkIfExtend(@NotNull World world, @NotNull TilePos tilePos) {
+    private void checkIfExtend(@NotNull World world, @NotNull TilePosc tilePos) {
         int data = world.getBlockData(tilePos);
         Direction direction = getDirection(data);
         boolean hasNeighborSignal = getNeighborSignal(world, tilePos, direction);
-        if(data == MASK_DIRECTION) {
+        if (data == MASK_DIRECTION) {
             return;
         }
-        if(hasNeighborSignal && !isPowered(data)) {
-            if(canPushLine(world, tilePos, direction, this.maxPushedBlocks)) {
+        if (hasNeighborSignal && !isPowered(data)) {
+            if (canPushLine(world, tilePos, direction, this.maxPushedBlocks)) {
                 world.setBlockData(tilePos, direction.getId() | MASK_POWERED);
                 world.triggerEvent(tilePos, EVENT_EXTEND, direction.getId());
             }
-        }
-        else if(!hasNeighborSignal && isPowered(data)) {
+        } else if (!hasNeighborSignal && isPowered(data)) {
             world.setBlockData(tilePos, direction.getId());
             world.triggerEvent(tilePos, EVENT_RETRACT, direction.getId());
         }
     }
 
-    private boolean getNeighborSignal(@NotNull World world, @NotNull TilePos tilePos, Direction direction) {
-        if(direction != Direction.DOWN && world.hasSignal(tilePos.add(0, -1, 0), Side.BOTTOM)) { return true; }
-        if(direction != Direction.UP && world.hasSignal(tilePos.add(0, 1, 0), Side.TOP)) { return true; }
-        if(direction != Direction.NORTH && world.hasSignal(tilePos.add(0, 0, -1), Side.NORTH)) { return true; }
-        if(direction != Direction.SOUTH && world.hasSignal(tilePos.add(0, 0, 1), Side.SOUTH)) { return true; }
-        if(direction != Direction.EAST && world.hasSignal(tilePos.add(1, 0, 0), Side.EAST)) { return true; }
-        if(direction != Direction.WEST && world.hasSignal(tilePos.add(-1, 0, 0), Side.WEST)) { return true; }
-        if(world.hasSignal(tilePos, Side.BOTTOM)) { return true;}
+    private boolean getNeighborSignal(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction) {
+        TilePos queryPos = new TilePos();
+        if (direction != Direction.DOWN && world.hasSignal(tilePos.add(0, -1, 0, queryPos), Side.BOTTOM)) {
+            return true;
+        }
+        if (direction != Direction.UP && world.hasSignal(tilePos.add(0, 1, 0, queryPos), Side.TOP)) {
+            return true;
+        }
+        if (direction != Direction.NORTH && world.hasSignal(tilePos.add(0, 0, -1, queryPos), Side.NORTH)) {
+            return true;
+        }
+        if (direction != Direction.SOUTH && world.hasSignal(tilePos.add(0, 0, 1, queryPos), Side.SOUTH)) {
+            return true;
+        }
+        if (direction != Direction.EAST && world.hasSignal(tilePos.add(1, 0, 0, queryPos), Side.EAST)) {
+            return true;
+        }
+        if (direction != Direction.WEST && world.hasSignal(tilePos.add(-1, 0, 0, queryPos), Side.WEST)) {
+            return true;
+        }
+        if (world.hasSignal(tilePos, Side.BOTTOM)) {
+            return true;
+        }
         // QC
-        if(direction != Direction.UP && world.hasSignal(tilePos.add(0, 2, 0), Side.TOP)) { return true; }
-        if(world.hasSignal(tilePos.add(0, 1, -1), Side.NORTH)) { return true; }
-        if(world.hasSignal(tilePos.add(0, 1, 1), Side.SOUTH)) { return true; }
-        if(world.hasSignal(tilePos.add(-1, 1, 0), Side.WEST)) { return true; }
-        return world.hasSignal(tilePos.add(1, 1, 0), Side.EAST);
+        if (direction != Direction.UP && world.hasSignal(tilePos.add(0, 2, 0, queryPos), Side.TOP)) {
+            return true;
+        }
+        if (world.hasSignal(tilePos.add(0, 1, -1, queryPos), Side.NORTH)) {
+            return true;
+        }
+        if (world.hasSignal(tilePos.add(0, 1, 1, queryPos), Side.SOUTH)) {
+            return true;
+        }
+        if (world.hasSignal(tilePos.add(-1, 1, 0, queryPos), Side.WEST)) {
+            return true;
+        }
+        return world.hasSignal(tilePos.add(1, 1, 0, queryPos), Side.EAST);
     }
 
     @Override
-    public void triggerEvent(@NotNull World world, @NotNull TilePos tilePos, int index, int data)
-    {
+    public void triggerEvent(@NotNull World world, @NotNull TilePosc tilePos, int index, int data) {
         Direction direction = getDirection(data);
         if (direction == Direction.NONE) return;
-        if(index == EVENT_EXTEND)
-        {
+        if (index == EVENT_EXTEND) {
             extendEvent(world, tilePos, data, direction);
-        }
-        else if(index == EVENT_RETRACT)
-        {
+        } else if (index == EVENT_RETRACT) {
             retractEvent(world, tilePos, data, direction);
         }
     }
 
-    public void extendEvent(@NotNull World world, @NotNull TilePos tilePos, int data, @NotNull Direction direction) {
-        if(tryExtend(world, tilePos, direction, this.maxPushedBlocks)) {
+    public void extendEvent(@NotNull World world, @NotNull TilePosc tilePos, int data, @NotNull Direction direction) {
+        if (tryExtend(world, tilePos, direction, this.maxPushedBlocks)) {
             world.setBlockDataNotify(tilePos, direction.getId() | MASK_POWERED);
-            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)tilePos.x + 0.5D, (double)tilePos.y + 0.5D, (double)tilePos.z + 0.5D, "tile.piston.out", 0.5F, world.rand.nextFloat() * 0.25F + 0.6F);
+            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "tile.piston.out", 0.5F, world.rand.nextFloat() * 0.25F + 0.6F);
         }
     }
 
-    public void retractEvent(@NotNull World world, @NotNull TilePos tilePos, int data, @NotNull Direction direction) {
-        TilePos shiftedPos = tilePos.add(direction);
+    public void retractEvent(@NotNull World world, @NotNull TilePosc tilePos, int data, @NotNull Direction direction) {
+        TilePos shiftedPos = tilePos.add(direction, new TilePos());
         TileEntity tileEntity = world.getTileEntity(shiftedPos);
-        if((tileEntity instanceof TileEntityMovingPistonBlock moving)) {
+        if ((tileEntity instanceof TileEntityMovingPistonBlock moving)) {
             if (!moving.isExtending()) {
                 moving.finalTick();
             } else {
@@ -193,52 +210,47 @@ public class BlockLogicPistonBase extends BlockLogic
         world.setBlockIdData(tilePos, Blocks.PISTON_MOVING.id(), direction.getId());
         world.replaceTileEntity(tilePos, BlockLogicPistonMoving.createTileEntity(this.block.id(), direction.getId(), null, direction, false, true));
         world.setBlockIdNotify(shiftedPos, 0);
-        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)tilePos.x + 0.5D, (double)tilePos.y + 0.5D, (double)tilePos.z + 0.5D, "tile.piston.in", 0.5F, world.rand.nextFloat() * 0.15F + 0.6F);
+        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "tile.piston.in", 0.5F, world.rand.nextFloat() * 0.15F + 0.6F);
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         int data = source.getBlockData(tilePos);
-        if(isPowered(data))
-        {
+        if (isPowered(data)) {
             return switch (getDirection(data)) {
-                case DOWN -> AABB.fromPool(0.0F, 0.25F, 0.0F, 1.0F, 1.0F, 1.0F);
-                case UP -> AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 0.75F, 1.0F);
-                case NORTH -> AABB.fromPool(0.0F, 0.0F, 0.25F, 1.0F, 1.0F, 1.0F);
-                case SOUTH -> AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.75F);
-                case WEST -> AABB.fromPool(0.25F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-                default -> AABB.fromPool(0.0F, 0.0F, 0.0F, 0.75F, 1.0F, 1.0F);
+                case DOWN -> new AABBd(0.0F, 0.25F, 0.0F, 1.0F, 1.0F, 1.0F);
+                case UP -> new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 0.75F, 1.0F);
+                case NORTH -> new AABBd(0.0F, 0.0F, 0.25F, 1.0F, 1.0F, 1.0F);
+                case SOUTH -> new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.75F);
+                case WEST -> new AABBd(0.25F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                default -> new AABBd(0.0F, 0.0F, 0.0F, 0.75F, 1.0F, 1.0F);
             };
-        } else
-        {
-            return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+        } else {
+            return new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         }
     }
 
     @Override
-	public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         int meta = world.getBlockData(tilePos);
         if ((meta & MASK_POWERED) == 0) return FullSupport.INSTANCE;
         Direction dir = getDirection(meta);
         return pistonSupportLookupTable[side.getId() * 6 + dir.getId()];
     }
 
-    public static Direction getDirection(int data)
-    {
+    public static Direction getDirection(int data) {
         return Direction.getDirectionById(data & MASK_DIRECTION);
     }
 
-    public static boolean isPowered(int data)
-    {
+    public static boolean isPowered(int data) {
         return (data & MASK_POWERED) != 0;
     }
-    
+
     protected boolean isPushable(int id, @NotNull World world, @NotNull TilePos tilePos, boolean canDestroy) {
         Block<?> block = Blocks.getBlock(id);
         if (block == null) return false;
@@ -251,15 +263,15 @@ public class BlockLogicPistonBase extends BlockLogic
     }
 
     @Override
-    public int getPistonPushReaction(@NotNull World world, @NotNull TilePos tilePos) {
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
         if (isPowered(world.getBlockData(tilePos))) {
             return Material.PISTON_CANT_PUSH;
         }
         return super.getPistonPushReaction(world, tilePos);
     }
 
-    protected boolean canPushLine(@NotNull World world, @NotNull TilePos tilePos, @NotNull Direction direction, int maxPushedBlocks) {
-        TilePos posO = tilePos.add(direction);
+    protected boolean canPushLine(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction, int maxPushedBlocks) {
+        TilePos posO = tilePos.add(direction, new TilePos());
         int blocks = 0;
         while (true) {
             if (blocks >= maxPushedBlocks + 1) {
@@ -292,8 +304,8 @@ public class BlockLogicPistonBase extends BlockLogic
         return true;
     }
 
-    public boolean tryCrush(@NotNull World world, @NotNull TilePos tilePos, @NotNull Direction direction) {
-        TilePos pos2 = tilePos.add(direction);
+    public boolean tryCrush(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction) {
+        TilePos pos2 = tilePos.add(direction, new TilePos());
         Block<?> block = world.getBlock(pos2);
         if (block == null) return true;
         world.playBlockEvent(null, pos2, LevelListener.EVENT_BLOCK_BREAK, world.getBlockId(pos2));
@@ -302,10 +314,9 @@ public class BlockLogicPistonBase extends BlockLogic
         return true;
     }
 
-    protected boolean tryExtend(@NotNull World world, @NotNull TilePos tilePos, @NotNull Direction direction, int maxPushedBlocks)
-    {
+    protected boolean tryExtend(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction, int maxPushedBlocks) {
         int data = world.getBlockData(tilePos);
-        TilePos posO = tilePos.add(direction);
+        TilePos posO = tilePos.add(direction, new TilePos());
         int blocks = 0;
         while (true) {
             if (blocks >= maxPushedBlocks + 1) {
@@ -342,7 +353,7 @@ public class BlockLogicPistonBase extends BlockLogic
             if (pushEntity instanceof TileEntityMovingPistonBlock && posP.equals(tilePos)) {
                 break;
             }
-            if(pushId == this.block.id() && posP.equals(tilePos)) {
+            if (pushId == this.block.id() && posP.equals(tilePos)) {
                 createPistonHeadAt(world, posO, data, direction);
             } else if (pushId == Blocks.PISTON_MOVING.id()) {
                 TileEntity old = world.getTileEntity(posP);
@@ -376,7 +387,7 @@ public class BlockLogicPistonBase extends BlockLogic
     }
 
     @Override
-    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         return MASK_DIRECTION;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
index f415fe016..a71f8ae16 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
@@ -10,19 +10,21 @@ import net.minecraft.core.entity.EntityFallingBlock;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.ArrayList;
 import java.util.List;
 
 public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
-    public static final double HEAD_THICKNESS_STEEL = 6/16d;
+    public static final double HEAD_THICKNESS_STEEL = 6 / 16d;
 
     private Entity flungBlock = null;
 
@@ -31,25 +33,25 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         int data = source.getBlockData(tilePos);
-        if(isPowered(data)) {
+        if (isPowered(data)) {
             return switch (getDirection(data)) {
-                case DOWN -> AABB.fromPool(0.0F, HEAD_THICKNESS_STEEL, 0.0F, 1.0F, 1.0F, 1.0F);
-                case UP -> AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1 - HEAD_THICKNESS_STEEL, 1.0F);
-                case NORTH -> AABB.fromPool(0.0F, 0.0F, HEAD_THICKNESS_STEEL, 1.0F, 1.0F, 1.0F);
-                case SOUTH -> AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1 - HEAD_THICKNESS_STEEL);
-                case WEST -> AABB.fromPool(HEAD_THICKNESS_STEEL, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-                default -> AABB.fromPool(0.0F, 0.0F, 0.0F, 1 - HEAD_THICKNESS_STEEL, 1.0F, 1.0F);
+                case DOWN -> new AABBd(0.0F, HEAD_THICKNESS_STEEL, 0.0F, 1.0F, 1.0F, 1.0F);
+                case UP -> new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1 - HEAD_THICKNESS_STEEL, 1.0F);
+                case NORTH -> new AABBd(0.0F, 0.0F, HEAD_THICKNESS_STEEL, 1.0F, 1.0F, 1.0F);
+                case SOUTH -> new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1 - HEAD_THICKNESS_STEEL);
+                case WEST -> new AABBd(HEAD_THICKNESS_STEEL, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                default -> new AABBd(0.0F, 0.0F, 0.0F, 1 - HEAD_THICKNESS_STEEL, 1.0F, 1.0F);
             };
         } else {
-            return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+            return new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         }
     }
 
     @Override
-    protected boolean canPushLine(@NotNull World world, @NotNull TilePos tilePos, @NotNull Direction direction, int maxPushedBlocks) {
-        TilePos posO = tilePos.add(direction);
+    protected boolean canPushLine(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction, int maxPushedBlocks) {
+        TilePos posO = tilePos.add(direction, new TilePos());
         int blocks = 0;
         boolean didCrush = false;
         while (true) {
@@ -82,7 +84,7 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
             blocks++;
         }
         if (!didCrush && blocks == 1) { // Block Flinging
-            posO.set(tilePos.x + direction.getOffsetX(), tilePos.y + direction.getOffsetY(), tilePos.z + direction.getOffsetZ());
+            tilePos.add(direction, posO);
             Block<?> block = world.getBlock(posO);
             if (block == null) return true;
             int blockMeta = world.getBlockData(posO);
@@ -107,8 +109,8 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
     }
 
     @Override
-    public boolean tryCrush(@NotNull World world, @NotNull TilePos tilePos, @NotNull Direction direction) {
-        TilePos pos2 = tilePos.add(direction);
+    public boolean tryCrush(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction) {
+        TilePos pos2 = tilePos.add(direction, new TilePos());
         Block<?> block = world.getBlock(pos2);
         if (block == null) return true;
         world.playBlockEvent(null, pos2, LevelListener.EVENT_BLOCK_BREAK, world.getBlockId(pos2));
@@ -118,10 +120,10 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
     }
 
     @Override
-    protected boolean tryExtend(@NotNull World world, @NotNull TilePos tilePos, @NotNull Direction direction, int maxPushedBlocks) {
+    protected boolean tryExtend(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction, int maxPushedBlocks) {
         if (world.isClientSide) { // "Fixes" steel pistons appearing to push the block they just flung
             int data = world.getBlockData(tilePos);
-            TilePos posO = tilePos.add(direction);
+            TilePos posO = tilePos.add(direction, new TilePos());
             int blocks = 0;
             while (true) {
                 if (blocks >= maxPushedBlocks + 1) {
@@ -158,8 +160,7 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
                     if (pushEntity instanceof TileEntityMovingPistonBlock && posP.equals(tilePos)) {
                         break;
                     }
-                    if(pushId == this.block.id() && posP.equals(tilePos))
-                    {
+                    if (pushId == this.block.id() && posP.equals(tilePos)) {
                         createPistonHeadAt(world, posO, data, direction);
                     }
                     if (!posP.equals(tilePos))
@@ -175,11 +176,12 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
     }
 
     @Override
-    public void extendEvent(@NotNull World world, @NotNull TilePos tilePos, int data, @NotNull Direction direction) {
-        List<Entity> entityList = new ArrayList<>(world.getEntitiesWithinAABBExcludingEntity(null, AABB.fromPool((double)tilePos.x + direction.getOffsetX(), (double)tilePos.y + direction.getOffsetY(), (double)tilePos.z + direction.getOffsetZ(), (double)tilePos.x + direction.getOffsetX() + 1, (double)tilePos.y + direction.getOffsetY() + 1, (double)tilePos.z + direction.getOffsetZ() + 1)));
-        for (Entity entity : entityList){
+    public void extendEvent(@NotNull World world, @NotNull TilePosc tilePos, int data, @NotNull Direction direction) {
+        List<Entity> entityList = new ArrayList<>(world.getEntitiesWithinAABBExcludingEntity(null, new AABBd((double) tilePos.x() + direction.getOffsetX(), (double) tilePos.y() + direction.getOffsetY(), (double) tilePos.z() + direction.getOffsetZ(), (double) tilePos.x() + direction.getOffsetX() + 1, (double) tilePos.y() + direction.getOffsetY() + 1, (double) tilePos.z() + direction.getOffsetZ() + 1)));
+        for (Entity entity : entityList) {
             /*Fix for 1 tick extensions not working properly*/
-            if (entity == null || entity.noPhysics || entity == this.flungBlock || entity.world.isClientSide && entity instanceof Player) continue;
+            if (entity == null || entity.noPhysics || entity == this.flungBlock || entity.world.isClientSide && entity instanceof Player)
+                continue;
             final double speed = 2;
             entity.fling(direction.getOffsetX() * speed, direction.getOffsetY() * speed, direction.getOffsetZ() * speed, 1f);
         }
@@ -189,7 +191,7 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
 
     @Override
     public void createPistonHeadAt(@NotNull World world, @NotNull TilePos tilePos, int data, @NotNull Direction direction) {
-        world.setBlockIdData(tilePos, Blocks.PISTON_MOVING.id(),  BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STEEL, direction.getId()));
+        world.setBlockIdData(tilePos, Blocks.PISTON_MOVING.id(), BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STEEL, direction.getId()));
         world.replaceTileEntity(tilePos, BlockLogicPistonMoving.createTileEntity(Blocks.PISTON_HEAD_STEEL.id(), BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STEEL, direction.getId()), null, direction, true, false));
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSticky.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSticky.java
index 2588efa7b..55368869b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSticky.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSticky.java
@@ -8,6 +8,7 @@ import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicPistonBaseSticky extends BlockLogicPistonBase {
@@ -16,10 +17,10 @@ public class BlockLogicPistonBaseSticky extends BlockLogicPistonBase {
     }
 
     @Override
-    public void retractEvent(@NotNull World world, @NotNull TilePos tilePos, int data, @NotNull Direction direction) {
-        TilePos posDir = tilePos.add(direction);
+    public void retractEvent(@NotNull World world, @NotNull TilePosc tilePos, int data, @NotNull Direction direction) {
+        TilePos posDir = tilePos.add(direction, new TilePos());
         TileEntity tileEntity = world.getTileEntity(posDir);
-        if((tileEntity instanceof TileEntityMovingPistonBlock moving)) {
+        if ((tileEntity instanceof TileEntityMovingPistonBlock moving)) {
             if (!moving.isExtending()) {
                 moving.finalTick();
             } else {
@@ -28,14 +29,14 @@ public class BlockLogicPistonBaseSticky extends BlockLogicPistonBase {
         }
         world.setBlockIdData(tilePos, Blocks.PISTON_MOVING.id(), direction.getId());
         world.replaceTileEntity(tilePos, BlockLogicPistonMoving.createTileEntity(this.block.id(), direction.getId(), null, direction, false, true));
-        TilePos pos1 = new TilePos(tilePos.x + direction.getOffsetX() * 2, tilePos.y + direction.getOffsetY() * 2,tilePos.z + direction.getOffsetZ() * 2);
+        TilePos pos1 = new TilePos(tilePos.x() + direction.getOffsetX() * 2, tilePos.y() + direction.getOffsetY() * 2, tilePos.z() + direction.getOffsetZ() * 2);
         int retractId = world.getBlockId(pos1);
         int retactMeta = world.getBlockData(pos1);
         TileEntity retractEntity = world.getTileEntity(pos1);
         boolean pulledMoving = false;
-        if(retractId == Blocks.PISTON_MOVING.id()) {
-            if((world.getTileEntity(pos1) instanceof TileEntityMovingPistonBlock movingPistonBlock)) {
-                if(movingPistonBlock.getDirection() == direction && movingPistonBlock.isExtending()) {
+        if (retractId == Blocks.PISTON_MOVING.id()) {
+            if ((world.getTileEntity(pos1) instanceof TileEntityMovingPistonBlock movingPistonBlock)) {
+                if (movingPistonBlock.getDirection() == direction && movingPistonBlock.isExtending()) {
                     movingPistonBlock.finalTick();
                     retractId = movingPistonBlock.getMovedId();
                     retactMeta = movingPistonBlock.getMovedData();
@@ -46,7 +47,7 @@ public class BlockLogicPistonBaseSticky extends BlockLogicPistonBase {
         }
         Block<?> retractedBlock = Blocks.getBlock(retractId);
         TilePos pos2 = new TilePos(tilePos);
-        if(!pulledMoving && retractedBlock != null &&
+        if (!pulledMoving && retractedBlock != null &&
             isPushable(retractId, world, pos1, false) &&
             (retractedBlock.getPistonPushReaction(world, pos1) == Material.PISTON_PUSHABLE || (retractedBlock.getLogic() instanceof BlockLogicPistonBase))) {
             if (!(retractEntity instanceof TileEntityMovingPistonBlock)) {
@@ -59,14 +60,15 @@ public class BlockLogicPistonBaseSticky extends BlockLogicPistonBase {
             world.setBlockIdData(pos2, Blocks.PISTON_MOVING.id(), retactMeta);
             world.replaceTileEntity(pos2, BlockLogicPistonMoving.createTileEntity(retractId, retactMeta, retractEntity, direction, false, false));
             world.notifyBlockChange(pos1, 0);
-        } else if(!pulledMoving) {
+        } else if (!pulledMoving) {
             world.setBlockIdNotify(posDir, 0);
         }
-        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)pos2.x + 0.5D, (double)pos2.y + 0.5D, (double)pos2.z + 0.5D, "tile.piston.in", 0.5F, world.rand.nextFloat() * 0.15F + 0.6F);
+        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) pos2.x + 0.5D, (double) pos2.y + 0.5D, (double) pos2.z + 0.5D, "tile.piston.in", 0.5F, world.rand.nextFloat() * 0.15F + 0.6F);
     }
+
     @Override
     public void createPistonHeadAt(@NotNull World world, @NotNull TilePos tilePos, int data, @NotNull Direction direction) {
-        world.setBlockIdData(tilePos, Blocks.PISTON_MOVING.id(),  BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STICKY, direction.getId()));
+        world.setBlockIdData(tilePos, Blocks.PISTON_MOVING.id(), BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STICKY, direction.getId()));
         world.replaceTileEntity(tilePos, BlockLogicPistonMoving.createTileEntity(Blocks.PISTON_HEAD.id(), BlockLogicPistonHead.setPistonType(BlockLogicPistonHead.TYPE_STICKY, direction.getId()), null, direction, true, false));
     }
 }
